import type { SyncCollection } from './types';
type Fetch = typeof fetch;
interface IClientOptions {
    baseUrl: string;
    space: string;
    environmentId: string;
    accessToken: string;
    logger?: typeof console['debug'];
}
/**
 * Creates a simple client compatible with react-native that only implements sync
 */
export declare function createSimpleClient(options: Partial<IClientOptions>): SimpleContentfulClient;
/**
 * A simple client compatible with react-native that only implements sync
 */
export declare class SimpleContentfulClient {
    private fetch;
    private options;
    private logger;
    constructor(options?: Partial<IClientOptions>, fetch?: Fetch);
    sync(query: any): Promise<SyncCollection>;
    private get;
}
export declare class NotFoundError extends Error {
}
export {};
