"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.NotFoundError = exports.SimpleContentfulClient = exports.createSimpleClient = void 0;
/**
 * The standard contentful client doesn't work in react-native
 * So we create one that implements sync only
 */
var wait_1 = require("async-toolbox/wait");
var util_1 = require("../util");
/**
 * Creates a simple client compatible with react-native that only implements sync
 */
function createSimpleClient(options) {
    return new SimpleContentfulClient(options);
}
exports.createSimpleClient = createSimpleClient;
/**
 * A simple client compatible with react-native that only implements sync
 */
var SimpleContentfulClient = /** @class */ (function () {
    function SimpleContentfulClient(options, fetch) {
        if (fetch === void 0) { fetch = globalThis.fetch; }
        this.fetch = fetch;
        this.options = __assign({ baseUrl: 'https://cdn.contentful.com', space: process.env.CONTENTFUL_SPACE_ID, accessToken: process.env.CONTENTFUL_ACCESS_TOKEN, environmentId: process.env.CONTENTFUL_ENVIRONMENT || 'master' }, options);
        this.logger = this.options.logger || console.debug;
    }
    SimpleContentfulClient.prototype.sync = function (query) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, space, environmentId, assets, deletedAssets, entries, deletedEntries, resp, body, nextSyncToken;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.options, space = _a.space, environmentId = _a.environmentId;
                        assets = [];
                        deletedAssets = [];
                        entries = [];
                        deletedEntries = [];
                        query = query.nextSyncToken ?
                            { sync_token: query.nextSyncToken } :
                            { initial: true };
                        return [4 /*yield*/, this.get("/spaces/".concat(space, "/environments/").concat(environmentId, "/sync"), query)];
                    case 1:
                        resp = _b.sent();
                        return [4 /*yield*/, resp.json()];
                    case 2:
                        body = _b.sent();
                        assets.push.apply(assets, __spreadArray([], __read(body.items.filter(util_1.isAsset)), false));
                        deletedAssets.push.apply(deletedAssets, __spreadArray([], __read(body.items.filter(util_1.isDeletedAsset)), false));
                        entries.push.apply(entries, __spreadArray([], __read(body.items.filter(util_1.isEntry)), false));
                        deletedEntries.push.apply(deletedEntries, __spreadArray([], __read(body.items.filter(util_1.isDeletedEntry)), false));
                        _b.label = 3;
                    case 3:
                        if (!body.nextPageUrl) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.get(body.nextPageUrl)];
                    case 4:
                        resp = _b.sent();
                        return [4 /*yield*/, resp.json()];
                    case 5:
                        body = (_b.sent());
                        assets.push.apply(assets, __spreadArray([], __read(body.items.filter(util_1.isAsset)), false));
                        deletedAssets.push.apply(deletedAssets, __spreadArray([], __read(body.items.filter(util_1.isDeletedAsset)), false));
                        entries.push.apply(entries, __spreadArray([], __read(body.items.filter(util_1.isEntry)), false));
                        deletedEntries.push.apply(deletedEntries, __spreadArray([], __read(body.items.filter(util_1.isDeletedEntry)), false));
                        return [3 /*break*/, 3];
                    case 6:
                        nextSyncToken = new URL(body.nextSyncUrl).searchParams.get('sync_token');
                        return [2 /*return*/, {
                                assets: assets,
                                deletedAssets: deletedAssets,
                                entries: entries,
                                deletedEntries: deletedEntries,
                                nextSyncToken: nextSyncToken,
                                toPlainObject: function () { return this; },
                                stringifySafe: function () { return JSON.stringify(this); }
                            }];
                }
            });
        });
    };
    SimpleContentfulClient.prototype.get = function (path, query) {
        if (query === void 0) { query = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var url, resp, reset;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        url = new URL(path, this.options.baseUrl);
                        Object.keys(query).forEach(function (k) {
                            var v = query[k];
                            if (v !== undefined && v !== null) {
                                url.searchParams.set(k, v.toString());
                            }
                        });
                        _a.label = 1;
                    case 1:
                        if (this.logger) {
                            this.logger('get', url.toString());
                        }
                        return [4 /*yield*/, this.fetch(url.toString(), {
                                method: 'GET',
                                headers: {
                                    Authorization: "Bearer ".concat(this.options.accessToken)
                                },
                                redirect: 'follow'
                            })];
                    case 2:
                        resp = _a.sent();
                        if (resp.status == 404) {
                            throw new NotFoundError("404: ".concat(path));
                        }
                        if (!(resp.status == 429)) return [3 /*break*/, 4];
                        reset = resp.headers.get('X-Contentful-RateLimit-Reset');
                        if (!reset) {
                            throw new Error('Rate-limited with no X-Contentful-RateLimit-Reset header!');
                        }
                        return [4 /*yield*/, (0, wait_1.wait)(parseFloat(reset) * 1000)];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        if (resp.status != 200) {
                            throw new Error("Unexpected status code ".concat(resp.status, " for '").concat(path, "'"));
                        }
                        _a.label = 5;
                    case 5:
                        if (resp.status != 200) return [3 /*break*/, 1];
                        _a.label = 6;
                    case 6: return [2 /*return*/, resp];
                }
            });
        });
    };
    return SimpleContentfulClient;
}());
exports.SimpleContentfulClient = SimpleContentfulClient;
// tslint:disable-next-line: max-classes-per-file
var NotFoundError = /** @class */ (function (_super) {
    __extends(NotFoundError, _super);
    function NotFoundError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return NotFoundError;
}(Error));
exports.NotFoundError = NotFoundError;
//# sourceMappingURL=simpleClient.js.map