import type { Asset, AssetCollection, Entry, EntryCollection, DeletedAsset, DeletedEntry, SyncItem } from '../contentful/types';
import type { ContentfulDataSource } from '.';
import { Syncable } from '../syncEngine';
import { Exportable } from '../backup';
export declare class InMemoryDataSource implements ContentfulDataSource, Syncable, Exportable {
    private readonly defaultLocale;
    private readonly _entries;
    private readonly _assets;
    private _syncToken;
    constructor(defaultLocale?: string);
    getToken(): string | null | undefined;
    setToken(token: string): void;
    index(syncItem: SyncItem): void;
    getAsset(id: string, query?: any): Asset | undefined;
    getAssets(query?: any): AssetCollection;
    getEntry<T>(id: string, query?: any): Entry<T> | undefined;
    getEntries<T = {
        [key: string]: any;
    }>(query?: any): EntryCollection<T>;
    export(): Generator<Entry<any> | Asset | DeletedEntry | DeletedAsset, void, unknown>;
    private parseQuery;
    private denormalizeForLocale;
}
