"use strict";
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.InMemoryDataSource = void 0;
var get_1 = __importDefault(require("lodash/get"));
var cloneDeep_1 = __importDefault(require("lodash/cloneDeep"));
var util_1 = require("../util");
var InMemoryDataSource = /** @class */ (function () {
    function InMemoryDataSource(defaultLocale) {
        if (defaultLocale === void 0) { defaultLocale = 'en-US'; }
        this.defaultLocale = defaultLocale;
        this._entries = new Map();
        this._assets = new Map();
    }
    InMemoryDataSource.prototype.getToken = function () {
        return this._syncToken;
    };
    InMemoryDataSource.prototype.setToken = function (token) {
        this._syncToken = token;
    };
    InMemoryDataSource.prototype.index = function (syncItem) {
        var _a;
        if ((0, util_1.isEntry)(syncItem) || (0, util_1.isDeletedEntry)(syncItem)) {
            var prev = this._entries.get(syncItem.sys.id);
            if (!prev || Date.parse(prev.sys.updatedAt) <= Date.parse(syncItem.sys.updatedAt)) {
                this._entries.set(syncItem.sys.id, (0, cloneDeep_1["default"])(syncItem));
            }
        }
        else if ((0, util_1.isAsset)(syncItem) || (0, util_1.isDeletedAsset)(syncItem)) {
            var prev = this._assets.get(syncItem.sys.id);
            if (!prev || Date.parse(prev.sys.updatedAt) <= Date.parse(syncItem.sys.updatedAt)) {
                this._assets.set(syncItem.sys.id, (0, cloneDeep_1["default"])(syncItem));
            }
        }
        else {
            throw new Error("Unrecognized sync item: ".concat((_a = syncItem === null || syncItem === void 0 ? void 0 : syncItem.sys) === null || _a === void 0 ? void 0 : _a.type));
        }
    };
    InMemoryDataSource.prototype.getAsset = function (id, query) {
        var asset = this._assets.get(id);
        if (asset && !(0, util_1.isDeletedAsset)(asset)) {
            return this.denormalizeForLocale(asset, (query === null || query === void 0 ? void 0 : query.locale) || this.defaultLocale);
        }
    };
    InMemoryDataSource.prototype.getAssets = function (query) {
        var e_1, _a;
        var filters = query ? this.parseQuery(query) : [];
        var skip = (query === null || query === void 0 ? void 0 : query.skip) || 0;
        var limit = (query === null || query === void 0 ? void 0 : query.limit) || 0;
        var skipped = 0;
        var matchCount = 0;
        var items = [];
        var _loop_1 = function (asset) {
            if ((0, util_1.isDeletedAsset)(asset)) {
                return "continue";
            }
            if (filters.findIndex(function (f) { return !f(asset); }) == -1) {
                // No filters returned false.
                matchCount++;
                if (skipped < skip) {
                    skipped++;
                    return "continue";
                }
                if (limit > 0 && items.length >= limit) {
                    return "continue";
                }
                items.push(this_1.denormalizeForLocale(asset, (query === null || query === void 0 ? void 0 : query.locale) || this_1.defaultLocale));
            }
        };
        var this_1 = this;
        try {
            for (var _b = __values(this._assets.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var asset = _c.value;
                _loop_1(asset);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return {
            total: matchCount,
            skip: skip,
            limit: limit,
            items: items
        };
    };
    InMemoryDataSource.prototype.getEntry = function (id, query) {
        var entry = this._entries.get(id);
        if (entry && !(0, util_1.isDeletedEntry)(entry)) {
            return this.denormalizeForLocale(entry, (query === null || query === void 0 ? void 0 : query.locale) || this.defaultLocale);
        }
    };
    InMemoryDataSource.prototype.getEntries = function (query) {
        var e_2, _a;
        var filters = query ? this.parseQuery(query) : [];
        var skip = (query === null || query === void 0 ? void 0 : query.skip) || 0;
        var limit = (query === null || query === void 0 ? void 0 : query.limit) || 0;
        var skipped = 0;
        var matchCount = 0;
        var items = [];
        var _loop_2 = function (entry) {
            if ((0, util_1.isDeletedEntry)(entry)) {
                return "continue";
            }
            if (filters.findIndex(function (f) { return !f(entry); }) == -1) {
                // No filters returned false.
                matchCount++;
                if (skipped < skip) {
                    skipped++;
                    return "continue";
                }
                if (limit > 0 && items.length >= limit) {
                    return "continue";
                }
                items.push(this_2.denormalizeForLocale(entry, (query === null || query === void 0 ? void 0 : query.locale) || this_2.defaultLocale));
            }
        };
        var this_2 = this;
        try {
            for (var _b = __values(this._entries.values()), _c = _b.next(); !_c.done; _c = _b.next()) {
                var entry = _c.value;
                _loop_2(entry);
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b["return"])) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return {
            total: matchCount,
            skip: skip,
            limit: limit,
            items: items
        };
    };
    InMemoryDataSource.prototype["export"] = function () {
        var _a, _b, v, e_3_1, _c, _d, v, e_4_1;
        var e_3, _e, e_4, _f;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    _g.trys.push([0, 5, 6, 7]);
                    _a = __values(this._entries.values()), _b = _a.next();
                    _g.label = 1;
                case 1:
                    if (!!_b.done) return [3 /*break*/, 4];
                    v = _b.value;
                    return [4 /*yield*/, v];
                case 2:
                    _g.sent();
                    _g.label = 3;
                case 3:
                    _b = _a.next();
                    return [3 /*break*/, 1];
                case 4: return [3 /*break*/, 7];
                case 5:
                    e_3_1 = _g.sent();
                    e_3 = { error: e_3_1 };
                    return [3 /*break*/, 7];
                case 6:
                    try {
                        if (_b && !_b.done && (_e = _a["return"])) _e.call(_a);
                    }
                    finally { if (e_3) throw e_3.error; }
                    return [7 /*endfinally*/];
                case 7:
                    _g.trys.push([7, 12, 13, 14]);
                    _c = __values(this._assets.values()), _d = _c.next();
                    _g.label = 8;
                case 8:
                    if (!!_d.done) return [3 /*break*/, 11];
                    v = _d.value;
                    return [4 /*yield*/, v];
                case 9:
                    _g.sent();
                    _g.label = 10;
                case 10:
                    _d = _c.next();
                    return [3 /*break*/, 8];
                case 11: return [3 /*break*/, 14];
                case 12:
                    e_4_1 = _g.sent();
                    e_4 = { error: e_4_1 };
                    return [3 /*break*/, 14];
                case 13:
                    try {
                        if (_d && !_d.done && (_f = _c["return"])) _f.call(_c);
                    }
                    finally { if (e_4) throw e_4.error; }
                    return [7 /*endfinally*/];
                case 14: return [2 /*return*/];
            }
        });
    };
    InMemoryDataSource.prototype.parseQuery = function (query) {
        var _this = this;
        var filters = Object.keys(query)
            .filter(function (key) { return !['skip', 'limit', 'locale', 'include'].includes(key); })
            .map(function (key) {
            if (key == 'content_type') {
                // special case
                return function (e) { return (0, util_1.isEntry)(e) && e.sys.contentType.sys.id == query.content_type; };
            }
            var expected = query[key];
            var op = 'eq';
            var match = /\[(\w+)\]$/.exec(key);
            if (match && match[1]) {
                op = match[1];
                key = key.substring(0, match.index);
            }
            var s = selector(key, _this.defaultLocale);
            switch (op) {
                case 'eq':
                    return eqOp(s, expected);
                case 'ne':
                    return neOp(s, expected);
                case 'in':
                    return inOp(s, expected);
                default:
                    throw new Error("Operator not implemented: '".concat(op, "'"));
            }
        });
        return filters;
    };
    InMemoryDataSource.prototype.denormalizeForLocale = function (e, locale) {
        e = (0, cloneDeep_1["default"])(e);
        if (locale == '*') {
            return e;
        }
        var hasAnyValuesForLocale = false;
        Object.keys(e.fields).forEach(function (field) {
            var value = e.fields[field];
            if (typeof value != 'object') {
                return;
            }
            // value is of type { 'en-US': something }
            if (locale in value) {
                hasAnyValuesForLocale = true;
                e.fields[field] = value[locale];
            }
        });
        if (!hasAnyValuesForLocale) {
            // fall back to default
            return this.denormalizeForLocale(e, this.defaultLocale);
        }
        e.sys.locale = locale;
        return e;
    };
    return InMemoryDataSource;
}());
exports.InMemoryDataSource = InMemoryDataSource;
var SysFields = [
    'id'
];
function selector(key, locale) {
    if (SysFields.includes(key)) {
        key = 'sys.' + key;
    }
    else if (!key.startsWith('fields.') && !key.startsWith('sys.')) {
        key = 'fields.' + key;
    }
    return function (e) {
        var value = (0, get_1["default"])(e, key);
        if (e.sys.locale || typeof value != 'object') {
            return value;
        }
        // this is a synced entry or locale=* query result
        if (locale in value) {
            return value[locale];
        }
        // This entry has no value for the given locale
        return undefined;
    };
}
function eqOp(selector, expected) {
    return function (e) {
        var value = selector(e);
        if (Array.isArray(value)) {
            // https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/search-parameters/array-equality-inequality
            return value.includes(expected);
        }
        return value == expected;
    };
}
function neOp(selector, expected) {
    return function (e) {
        var value = selector(e);
        if (Array.isArray(value)) {
            // https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/search-parameters/array-equality-inequality
            return !value.includes(expected);
        }
        return value != expected;
    };
}
function inOp(selector, expected) {
    return function (e) {
        var value = selector(e);
        if (Array.isArray(value)) {
            // https://www.contentful.com/developers/docs/references/content-delivery-api/#/reference/search-parameters/array-equality-inequality
            return expected.findIndex(function (exp) { return value.includes(exp); }) != -1;
        }
        return expected.includes(value);
    };
}
//# sourceMappingURL=in-memory-data-source.js.map