"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var inflection_1 = __importDefault(require("inflection"));
var types_1 = require("../types");
var util_1 = require("../../util");
var QueryResolverBuilder = /** @class */ (function () {
    function QueryResolverBuilder(dataSource, options, contentTypeId) {
        this.dataSource = dataSource;
        this.options = options;
        this.contentTypeId = contentTypeId;
    }
    QueryResolverBuilder.prototype.build = function () {
        var resolvers = {};
        var typeName = (0, util_1.idToName)(this.contentTypeId);
        var queryFieldName = inflection_1["default"].camelize(typeName, true);
        resolvers[queryFieldName] = this.buildEntryResolver();
        resolvers["".concat(queryFieldName, "Collection")] = this.buildCollectionResolver();
        return {
            Query: resolvers
        };
    };
    QueryResolverBuilder.prototype.buildEntryResolver = function () {
        var _this = this;
        var dataSource = this.dataSource;
        var namespace = this.options.namespace;
        if (this.contentTypeId == 'Asset') {
            var AssetTypeName_1 = (0, types_1.namespacedTypeName)('Asset', namespace);
            return function (_, args) { return __awaiter(_this, void 0, void 0, function () {
                var entry;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!args || !args.id) {
                                throw new Error('ID must be provided');
                            }
                            return [4 /*yield*/, dataSource.getAsset(args.id)];
                        case 1:
                            entry = _a.sent();
                            if (!entry) {
                                return [2 /*return*/, null];
                            }
                            return [2 /*return*/, __assign({ __typename: AssetTypeName_1, _id: entry.sys.id }, entry)];
                    }
                });
            }); };
        }
        return function (_, args) { return __awaiter(_this, void 0, void 0, function () {
            var entry, typename;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!args || !args.id) {
                            throw new Error('ID must be provided');
                        }
                        return [4 /*yield*/, dataSource.getEntry(args.id)];
                    case 1:
                        entry = _a.sent();
                        if (!entry) {
                            return [2 /*return*/, null];
                        }
                        typename = (0, types_1.namespacedTypeName)((0, util_1.idToName)(entry.sys.contentType.sys.id), namespace);
                        return [2 /*return*/, __assign({ __typename: typename, _id: entry.sys.id }, entry)];
                }
            });
        }); };
    };
    QueryResolverBuilder.prototype.buildCollectionResolver = function () {
        var _this = this;
        var dataSource = this.dataSource;
        var contentTypeId = this.contentTypeId;
        var namespace = this.options.namespace;
        if (this.contentTypeId == 'Asset') {
            var AssetTypeName_2 = (0, types_1.namespacedTypeName)('Asset', namespace);
            return function (_, args) { return __awaiter(_this, void 0, void 0, function () {
                var collection;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, dataSource.getAssets(__assign({}, args))];
                        case 1:
                            collection = _a.sent();
                            return [2 /*return*/, {
                                    __typename: AssetTypeName_2 + 'Collection',
                                    _id: (0, util_1.generateUUID)(),
                                    skip: collection.skip,
                                    limit: collection.limit,
                                    total: collection.total,
                                    items: collection.items.map(function (asset) { return (__assign({ __typename: AssetTypeName_2, _id: asset.sys.id }, asset)); })
                                }];
                    }
                });
            }); };
        }
        if (this.contentTypeId == 'Entry') {
            // special case - no content_type and no filters, browse all entries
            return function (_, args) { return __awaiter(_this, void 0, void 0, function () {
                var collection, EntryTypeName;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0: return [4 /*yield*/, dataSource.getEntries(__assign({}, args))];
                        case 1:
                            collection = _a.sent();
                            EntryTypeName = (0, types_1.namespacedTypeName)('Entry', namespace);
                            return [2 /*return*/, {
                                    __typename: EntryTypeName + 'Collection',
                                    _id: (0, util_1.generateUUID)(),
                                    skip: collection.skip,
                                    limit: collection.limit,
                                    total: collection.total,
                                    items: collection.items.map(function (entry) {
                                        // each entry may be a different type
                                        var typename = (0, types_1.namespacedTypeName)((0, util_1.idToName)(entry.sys.contentType.sys.id), namespace);
                                        return __assign({ __typename: typename, _id: entry.sys.id }, entry);
                                    })
                                }];
                    }
                });
            }); };
        }
        return function (_, args) { return __awaiter(_this, void 0, void 0, function () {
            var collection, EntryTypeName;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataSource.getEntries(__assign({ content_type: contentTypeId }, args))];
                    case 1:
                        collection = _a.sent();
                        EntryTypeName = (0, types_1.namespacedTypeName)((0, util_1.idToName)(contentTypeId), namespace);
                        return [2 /*return*/, {
                                __typename: EntryTypeName + 'Collection',
                                _id: (0, util_1.generateUUID)(),
                                skip: collection.skip,
                                limit: collection.limit,
                                total: collection.total,
                                items: collection.items.map(function (entry) { return (__assign({ __typename: EntryTypeName, _id: entry.sys.id }, entry)); })
                            }];
                }
            });
        }); };
    };
    return QueryResolverBuilder;
}());
exports["default"] = QueryResolverBuilder;
//# sourceMappingURL=query-resolver-builder.js.map