import { GraphQLSchema } from 'graphql';
import { ContentType } from '../../contentful/types';
export type SchemaBuilderOptions = {
    contentTypes: ContentType[];
    /**
     * Prefixes all types with this namespace
     */
    namespace?: string;
    /**
     * Wraps all top level queries in this namespace
     */
    queryNamespace?: string;
};
export default class SchemaBuilder {
    private readonly options;
    private readonly namespace;
    constructor(options: SchemaBuilderOptions);
    build(): GraphQLSchema;
}
