"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
exports.addInclude = exports.withInclude = void 0;
var util_1 = require("./util");
/**
 * Wraps a data source to automatically resolve linked entries and assets,
 * replacing links recursively down the tree by fetching the linked entries
 * by ID.
 */
function withInclude(dataSource) {
    var _this = this;
    if (dataSource.__withInclude) {
        // We've already wrapped this data source
        return dataSource;
    }
    var oldGetEntries = dataSource.getEntries;
    return Object.assign(dataSource, {
        __withInclude: true,
        getEntries: function (query) { return __awaiter(_this, void 0, void 0, function () {
            var result, i, _a, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        if ((query === null || query === void 0 ? void 0 : query.include) && query.include > 10)
                            throw new Error('Maximum include depth exceeded (10)');
                        return [4 /*yield*/, oldGetEntries.call(dataSource, query)];
                    case 1:
                        result = _c.sent();
                        if (!(query === null || query === void 0 ? void 0 : query.include))
                            return [2 /*return*/, result];
                        i = 0;
                        _c.label = 2;
                    case 2:
                        if (!(i < result.items.length)) return [3 /*break*/, 5];
                        _a = result.items;
                        _b = i;
                        return [4 /*yield*/, resolveEntry.call(dataSource, result.items[i], query.include)];
                    case 3:
                        _a[_b] = _c.sent();
                        _c.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5: return [2 /*return*/, result];
                }
            });
        }); },
        resolveEntry: resolveEntry.bind(dataSource)
    });
}
exports.withInclude = withInclude;
function resolveEntry(entry, depth) {
    return __awaiter(this, void 0, void 0, function () {
        var _a, _b, field, value, i, _c, _d, _e, _f, e_1_1;
        var e_1, _g;
        return __generator(this, function (_h) {
            switch (_h.label) {
                case 0:
                    if (depth <= 0) {
                        return [2 /*return*/, entry];
                    }
                    _h.label = 1;
                case 1:
                    _h.trys.push([1, 11, 12, 13]);
                    _a = __values(Object.keys(entry.fields)), _b = _a.next();
                    _h.label = 2;
                case 2:
                    if (!!_b.done) return [3 /*break*/, 10];
                    field = _b.value;
                    value = entry.fields[field];
                    if (!Array.isArray(value)) return [3 /*break*/, 7];
                    i = 0;
                    _h.label = 3;
                case 3:
                    if (!(i < value.length)) return [3 /*break*/, 6];
                    _c = value;
                    _d = i;
                    return [4 /*yield*/, resolveValue.call(this, value[i], depth)];
                case 4:
                    _c[_d] = _h.sent();
                    _h.label = 5;
                case 5:
                    i++;
                    return [3 /*break*/, 3];
                case 6: return [3 /*break*/, 9];
                case 7:
                    _e = entry.fields;
                    _f = field;
                    return [4 /*yield*/, resolveValue.call(this, value, depth)];
                case 8:
                    _e[_f] = _h.sent();
                    _h.label = 9;
                case 9:
                    _b = _a.next();
                    return [3 /*break*/, 2];
                case 10: return [3 /*break*/, 13];
                case 11:
                    e_1_1 = _h.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 13];
                case 12:
                    try {
                        if (_b && !_b.done && (_g = _a["return"])) _g.call(_a);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 13: return [2 /*return*/, entry];
            }
        });
    });
}
function resolveValue(value, depth) {
    return __awaiter(this, void 0, void 0, function () {
        var entry;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!(0, util_1.isEntryLink)(value)) return [3 /*break*/, 2];
                    return [4 /*yield*/, this.getEntry(value.sys.id)];
                case 1:
                    entry = _a.sent();
                    if (entry) {
                        return [2 /*return*/, resolveEntry.call(this, entry, depth - 1)];
                    }
                    return [3 /*break*/, 5];
                case 2:
                    if (!(0, util_1.isAssetLink)(value)) return [3 /*break*/, 4];
                    return [4 /*yield*/, this.getAsset(value.sys.id)];
                case 3: return [2 /*return*/, _a.sent()];
                case 4: return [2 /*return*/, value];
                case 5: return [2 /*return*/];
            }
        });
    });
}
/**
 * Enhances a DataSource to automatically resolve linked entries and assets,
 * replacing links recursively down the tree by fetching the linked entries
 * by ID.
 */
function addInclude(dataSource) {
    withInclude(dataSource);
}
exports.addInclude = addInclude;
//# sourceMappingURL=include.js.map