"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
/* eslint-disable @typescript-eslint/no-var-requires */
var fs_1 = __importDefault(require("fs"));
var path = __importStar(require("path"));
var yargs = __importStar(require("yargs"));
var util_1 = require("util");
var cross_fetch_1 = __importDefault(require("cross-fetch"));
var schema_downloader_1 = __importDefault(require("./schema-downloader"));
var argv = yargs
    .option('file', {
    alias: 'f',
    type: 'string',
    describe: 'The location on disk of the schema file.'
})
    .option('out', {
    alias: 'o',
    type: 'string',
    describe: 'Where to place the generated gql file.'
})
    .option('namespace', {
    type: 'string',
    describe: 'Prefixes all types with a certain name'
})
    .option('queryNamespace', {
    type: 'string',
    describe: 'Wraps the top level Query object inside a field with this name'
})
    .option('skip-download', {
    boolean: true,
    describe: 'Skip re-downloading the schema file from the Contentful space'
})
    .option('managementToken', {
    alias: 'm',
    type: 'string',
    describe: 'The Contentful management token.  Defaults to the env var CONTENTFUL_MANAGEMENT_TOKEN'
})
    .option('space', {
    alias: 's',
    type: 'string',
    describe: 'The Contentful space ID. Defaults to the env var CONTENTFUL_SPACE_ID'
})
    .option('environment', {
    alias: 'e',
    type: 'string',
    describe: 'The Contentful environment.  Defaults to the env var CONTENTFUL_ENVIRONMENT or \'master\''
})
    .option('verbose', {
    boolean: true,
    alias: 'v',
    describe: 'Enable verbose logging'
}).argv;
var defaultLogger = {
    debug: function () { return; }
};
var verboseLogger = {
    debug: function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        // debug to stderr because we'll print the GQL schema to stdout
        return console.error.call(this, args);
    }
};
var pathExists = (0, util_1.promisify)(fs_1["default"].exists);
var mkdir = (0, util_1.promisify)(fs_1["default"].mkdir);
var writeFile = (0, util_1.promisify)(fs_1["default"].writeFile);
var readFile = (0, util_1.promisify)(fs_1["default"].readFile);
// tslint:disable-next-line:no-shadowed-variable
function Run(args) {
    return __awaiter(this, void 0, void 0, function () {
        var options, schemaFile, contentfulSchema, _a, _b, createSchema, printSchema, schema, dirname;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    options = __assign({ filename: args.file || './contentful-schema.json', logger: args.verbose ? verboseLogger : defaultLogger }, args);
                    schemaFile = options.filename;
                    if (!!options['skip-download']) return [3 /*break*/, 2];
                    return [4 /*yield*/, (0, schema_downloader_1["default"])(options, {
                            fetch: cross_fetch_1["default"]
                        })];
                case 1:
                    _c.sent();
                    console.log('Downloaded schema to', schemaFile);
                    _c.label = 2;
                case 2: return [4 /*yield*/, pathExists(schemaFile)];
                case 3:
                    if (!(_c.sent())) {
                        throw new Error("Schema file does not exist at '".concat(schemaFile, "'!  Please download it with the --download option ."));
                    }
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, readFile(schemaFile)];
                case 4:
                    contentfulSchema = _b.apply(_a, [(_c.sent()).toString()]);
                    try {
                        createSchema = require('./graphql/index').createSchema;
                        printSchema = require('graphql').printSchema;
                    }
                    catch (err) {
                        console.error('Skipping GraphQL schema generation because graphql is not installed.  Please install graphql to generate a GraphQL schema.');
                        return [2 /*return*/];
                    }
                    schema = createSchema({
                        contentTypes: contentfulSchema.contentTypes,
                        namespace: options.namespace,
                        queryNamespace: options.queryNamespace
                    });
                    if (!(options.out && options.out != '-')) return [3 /*break*/, 9];
                    dirname = path.dirname(options.out);
                    return [4 /*yield*/, pathExists(dirname)];
                case 5:
                    if (!!(_c.sent())) return [3 /*break*/, 7];
                    return [4 /*yield*/, mkdir(dirname)];
                case 6:
                    _c.sent();
                    _c.label = 7;
                case 7: return [4 /*yield*/, writeFile(options.out, printSchema(schema))];
                case 8:
                    _c.sent();
                    return [3 /*break*/, 10];
                case 9:
                    console.log(printSchema(schema));
                    _c.label = 10;
                case 10: return [2 /*return*/];
            }
        });
    });
}
var file = './contentful-schema.json';
if (fs_1["default"].existsSync('db') && fs_1["default"].statSync('db').isDirectory()) {
    file = './db/contentful-schema.json';
}
var args = Object.assign({
    file: file
}, argv);
if (typeof (args.download) == 'undefined') {
    if (args.managementToken && args.space && args.environment) {
        args.download = true;
    }
}
else if (typeof (args.download) == 'string') {
    args.download = args.download == 'true';
}
Run(args)["catch"](function (err) {
    return console.error('An unexpected error occurred!', err);
});
//# sourceMappingURL=main.js.map