import React from 'react';
import { ContentfulDataSource } from '../dataSource';
import { DataSourceWithResolve } from '../resolve';
interface LocalSchemaContext {
    dataSource: DataSourceWithResolve;
    revision: number;
    resync: () => Promise<void> | undefined;
}
export interface LocalSchemaProviderProps {
    dataSource: ContentfulDataSource;
    /**
     * The component to render while waiting for restore from backup/sync.
     * By default, this will render an empty screen.
     */
    Loading?: React.ComponentType;
}
/**
 * Provides a data source to power the query hooks
 */
export declare function LocalSchemaProvider({ children, dataSource, Loading }: React.PropsWithChildren<LocalSchemaProviderProps>): React.ReactElement<{}, string | React.JSXElementConstructor<any>> | React.FunctionComponentElement<React.ProviderProps<LocalSchemaContext>> | null;
export declare function useDataSource(): readonly [DataSourceWithResolve, number, () => Promise<void> | undefined];
export {};
