import type { Asset } from '../../contentful/types';
/**
 * The result is in one of 3 states:
 * 1. Loading, asset not available
 * 2. Error, asset may or may not be available
 * 3. Success, but asset may not have been found (undefined)
 *
 * Re-running the query does not set "loading: true", the loading flag is intended
 * for the initial load use case.
 */
export type UseFindAssetResult = [
    Asset | null | undefined,
    {
        error?: undefined;
        loading: boolean;
        refreshing: boolean;
    },
    () => Promise<void>
];
export declare function useFindAsset(id: string): UseFindAssetResult;
