"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
exports.__esModule = true;
exports.useFindEntry = void 0;
var react_1 = require("react");
var context_1 = require("../context");
function useFindEntry(id, options) {
    var _this = this;
    var _a = __read((0, context_1.useDataSource)(), 3), dataSource = _a[0], updatedAt = _a[1], refresh = _a[2];
    var _b = __read((0, react_1.useState)(), 2), found = _b[0], setFound = _b[1];
    var _c = __read((0, react_1.useState)(true), 2), loading = _c[0], setLoading = _c[1];
    var _d = __read((0, react_1.useState)(false), 2), refreshing = _d[0], setRefreshing = _d[1];
    var _e = __read((0, react_1.useState)(), 2), error = _e[0], setError = _e[1];
    (0, react_1.useEffect)(function () {
        var doIt = function () { return __awaiter(_this, void 0, void 0, function () {
            var result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, dataSource.getEntry(id)];
                    case 1:
                        result = _a.sent();
                        if (!(result && (options === null || options === void 0 ? void 0 : options.include))) return [3 /*break*/, 3];
                        return [4 /*yield*/, dataSource.resolveEntry(result, options.include)];
                    case 2:
                        result = _a.sent();
                        _a.label = 3;
                    case 3:
                        setFound(result);
                        return [2 /*return*/];
                }
            });
        }); };
        setRefreshing(true);
        setError(undefined);
        doIt()["catch"](function (e) { return setError(e); })["finally"](function () {
            setLoading(false);
            setRefreshing(false);
        });
    }, [id, updatedAt, options === null || options === void 0 ? void 0 : options.include]);
    return [found, { loading: loading, error: error, refreshing: refreshing }, refresh];
}
exports.useFindEntry = useFindEntry;
//# sourceMappingURL=useFindEntry.js.map