import type { EntryCollection } from '../../contentful/types';
/**
 * The result is in one of 3 states:
 * 1. Loading, no entries available
 * 2. Error, entries may or may not be available
 * 3. Success, entries are available
 *
 * Re-running the query does not set "loading: true", the loading flag is intended
 * for the initial load use case.
 */
export type UseQueryEntriesResult<T> = [
    EntryCollection<T>,
    {
        error?: Error;
        loading: boolean;
        refreshing: boolean;
    },
    () => Promise<void>
];
export declare function useQueryEntries<T = any>(contentType: string, query?: any): UseQueryEntriesResult<T>;
