"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.SchemaDownloader = void 0;
var async_toolbox_1 = require("async-toolbox");
var fs_1 = __importDefault(require("fs"));
var client_1 = require("./client");
var defaults_1 = __importDefault(require("../defaults"));
/**
 * Downloads the Contentful schema via the management API and creates
 * the contentful-schema.json file.
 *
 *
 * @param options (Optional) Where to store the contentful content type file
 *   (default: './contentful-schema.json')
 * @returns
 */
function downloadContentfulSchema(options, dependencies) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, new SchemaDownloader(__assign(__assign({}, defaults_1["default"]), options), __assign({}, dependencies)).downloadSchema()];
                case 1: return [2 /*return*/, _a.sent()];
            }
        });
    });
}
exports["default"] = downloadContentfulSchema;
var SchemaDownloader = /** @class */ (function () {
    function SchemaDownloader(options, dependencies) {
        var _this = this;
        this.responseLogger = function (response) {
            _this.options.logger.debug(response.status, response.url);
        };
        var opts = Object.assign({
            filename: './contentful-schema.json',
            managementToken: process.env.CONTENTFUL_MANAGEMENT_TOKEN,
            space: process.env.CONTENTFUL_SPACE_ID,
            environment: process.env.CONTENTFUL_ENVIRONMENT || 'master',
            logger: { debug: function () { return undefined; } }
        }, options);
        if (!opts.managementToken) {
            throw new Error('No managementToken given!');
        }
        if (!opts.space) {
            throw new Error('Space ID not given!');
        }
        this.fetch = (dependencies === null || dependencies === void 0 ? void 0 : dependencies.fetch) || globalThis.fetch;
        this.options = opts;
        this.client = new client_1.SimpleCMAClient({
            spaceId: opts.space,
            environmentId: opts.environment,
            accessToken: opts.managementToken,
            responseLogger: this.responseLogger
        }, this.fetch);
        this.semaphore = new async_toolbox_1.Limiter({
            interval: 'second',
            tokensPerInterval: 4
        });
    }
    SchemaDownloader.prototype.downloadSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a, contentTypes, editorInterfaces;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, this.getSchemaFromSpace()
                        // Use callback API to avoid dependency on fs-extra
                    ];
                    case 1:
                        _a = _b.sent(), contentTypes = _a.contentTypes, editorInterfaces = _a.editorInterfaces;
                        // Use callback API to avoid dependency on fs-extra
                        return [2 /*return*/, new Promise(function (res, rej) {
                                fs_1["default"].writeFile(_this.options.filename, JSON.stringify({
                                    contentTypes: contentTypes,
                                    editorInterfaces: editorInterfaces
                                }, undefined, '  '), function (ex) {
                                    if (ex) {
                                        return rej(ex);
                                    }
                                    // contentful-shell and the wcc-contentful gem both add a newline at the end of the file.
                                    fs_1["default"].appendFile(_this.options.filename, '\n', function (ex) {
                                        if (ex) {
                                            return rej(ex);
                                        }
                                        res();
                                    });
                                });
                            })];
                }
            });
        });
    };
    SchemaDownloader.prototype.getSchemaFromSpace = function () {
        return __awaiter(this, void 0, void 0, function () {
            var contentTypesResp, editorInterfaces, contentTypes;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.semaphore.lock(function () {
                            return toArray(_this.client.getContentTypes());
                        })];
                    case 1:
                        contentTypesResp = _a.sent();
                        return [4 /*yield*/, Promise.all(contentTypesResp.map(function (ct) {
                                return _this.semaphore.lock(function () { return __awaiter(_this, void 0, void 0, function () {
                                    var _a, _b;
                                    return __generator(this, function (_c) {
                                        switch (_c.label) {
                                            case 0:
                                                _a = sortControls;
                                                _b = stripSys;
                                                return [4 /*yield*/, this.client.getEditorInterface(ct.sys.id)];
                                            case 1: return [2 /*return*/, _a.apply(void 0, [_b.apply(void 0, [_c.sent()])])];
                                        }
                                    });
                                }); });
                            }))];
                    case 2:
                        editorInterfaces = (_a.sent()).sort(byContentType);
                        contentTypes = contentTypesResp.map(function (ct) {
                            return stripSys(ct);
                        })
                            .sort(byId);
                        return [2 /*return*/, {
                                contentTypes: contentTypes,
                                editorInterfaces: editorInterfaces
                            }];
                }
            });
        });
    };
    return SchemaDownloader;
}());
exports.SchemaDownloader = SchemaDownloader;
function toArray(generator) {
    var _a, generator_1, generator_1_1;
    var _b, e_1, _c, _d;
    return __awaiter(this, void 0, void 0, function () {
        var results, item, e_1_1;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    results = [];
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 6, 7, 12]);
                    _a = true, generator_1 = __asyncValues(generator);
                    _e.label = 2;
                case 2: return [4 /*yield*/, generator_1.next()];
                case 3:
                    if (!(generator_1_1 = _e.sent(), _b = generator_1_1.done, !_b)) return [3 /*break*/, 5];
                    _d = generator_1_1.value;
                    _a = false;
                    try {
                        item = _d;
                        results.push(item);
                    }
                    finally {
                        _a = true;
                    }
                    _e.label = 4;
                case 4: return [3 /*break*/, 2];
                case 5: return [3 /*break*/, 12];
                case 6:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 12];
                case 7:
                    _e.trys.push([7, , 10, 11]);
                    if (!(!_a && !_b && (_c = generator_1["return"]))) return [3 /*break*/, 9];
                    return [4 /*yield*/, _c.call(generator_1)];
                case 8:
                    _e.sent();
                    _e.label = 9;
                case 9: return [3 /*break*/, 11];
                case 10:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 11: return [7 /*endfinally*/];
                case 12: return [2 /*return*/, results];
            }
        });
    });
}
function stripSys(obj) {
    return __assign(__assign({}, obj), { sys: {
            id: obj.sys.id,
            type: obj.sys.type,
            contentType: obj.sys.contentType
        } });
}
function sortControls(editorInterface) {
    return {
        sys: editorInterface.sys,
        controls: editorInterface.controls
            .sort(byFieldId)
            .map(function (c) { return ({
            fieldId: c.fieldId,
            settings: c.settings,
            widgetId: c.widgetId
        }); })
    };
}
function byId(a, b) {
    return a.sys.id.localeCompare(b.sys.id);
}
function byContentType(a, b) {
    return a.sys.contentType.sys.id.localeCompare(b.sys.contentType.sys.id);
}
function byFieldId(a, b) {
    return a.fieldId.localeCompare(b.fieldId);
}
//# sourceMappingURL=index.js.map