"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
exports.__esModule = true;
exports.hasSync = exports.isSyncable = exports.addSync = exports.withSync = exports.SyncEngine = void 0;
var SyncEngine = /** @class */ (function () {
    function SyncEngine(dataSource, client) {
        this.dataSource = dataSource;
        this.client = client;
    }
    SyncEngine.prototype.sync = function () {
        return __awaiter(this, void 0, void 0, function () {
            var token, collection, _a, _b, e, e_1_1, _c, _d, e, e_2_1, _e, _f, e, e_3_1, _g, _h, e, e_4_1;
            var e_1, _j, e_2, _k, e_3, _l, e_4, _m;
            return __generator(this, function (_o) {
                switch (_o.label) {
                    case 0: return [4 /*yield*/, this.dataSource.getToken()];
                    case 1:
                        token = _o.sent();
                        return [4 /*yield*/, this.client.sync(token ?
                                { nextSyncToken: token } :
                                { initial: true })];
                    case 2:
                        collection = _o.sent();
                        _o.label = 3;
                    case 3:
                        _o.trys.push([3, 8, 9, 10]);
                        _a = __values(collection.entries), _b = _a.next();
                        _o.label = 4;
                    case 4:
                        if (!!_b.done) return [3 /*break*/, 7];
                        e = _b.value;
                        return [4 /*yield*/, this.dataSource.index(e)];
                    case 5:
                        _o.sent();
                        _o.label = 6;
                    case 6:
                        _b = _a.next();
                        return [3 /*break*/, 4];
                    case 7: return [3 /*break*/, 10];
                    case 8:
                        e_1_1 = _o.sent();
                        e_1 = { error: e_1_1 };
                        return [3 /*break*/, 10];
                    case 9:
                        try {
                            if (_b && !_b.done && (_j = _a["return"])) _j.call(_a);
                        }
                        finally { if (e_1) throw e_1.error; }
                        return [7 /*endfinally*/];
                    case 10:
                        _o.trys.push([10, 15, 16, 17]);
                        _c = __values(collection.assets), _d = _c.next();
                        _o.label = 11;
                    case 11:
                        if (!!_d.done) return [3 /*break*/, 14];
                        e = _d.value;
                        return [4 /*yield*/, this.dataSource.index(e)];
                    case 12:
                        _o.sent();
                        _o.label = 13;
                    case 13:
                        _d = _c.next();
                        return [3 /*break*/, 11];
                    case 14: return [3 /*break*/, 17];
                    case 15:
                        e_2_1 = _o.sent();
                        e_2 = { error: e_2_1 };
                        return [3 /*break*/, 17];
                    case 16:
                        try {
                            if (_d && !_d.done && (_k = _c["return"])) _k.call(_c);
                        }
                        finally { if (e_2) throw e_2.error; }
                        return [7 /*endfinally*/];
                    case 17:
                        _o.trys.push([17, 22, 23, 24]);
                        _e = __values(collection.deletedEntries), _f = _e.next();
                        _o.label = 18;
                    case 18:
                        if (!!_f.done) return [3 /*break*/, 21];
                        e = _f.value;
                        return [4 /*yield*/, this.dataSource.index(e)];
                    case 19:
                        _o.sent();
                        _o.label = 20;
                    case 20:
                        _f = _e.next();
                        return [3 /*break*/, 18];
                    case 21: return [3 /*break*/, 24];
                    case 22:
                        e_3_1 = _o.sent();
                        e_3 = { error: e_3_1 };
                        return [3 /*break*/, 24];
                    case 23:
                        try {
                            if (_f && !_f.done && (_l = _e["return"])) _l.call(_e);
                        }
                        finally { if (e_3) throw e_3.error; }
                        return [7 /*endfinally*/];
                    case 24:
                        _o.trys.push([24, 29, 30, 31]);
                        _g = __values(collection.deletedAssets), _h = _g.next();
                        _o.label = 25;
                    case 25:
                        if (!!_h.done) return [3 /*break*/, 28];
                        e = _h.value;
                        return [4 /*yield*/, this.dataSource.index(e)];
                    case 26:
                        _o.sent();
                        _o.label = 27;
                    case 27:
                        _h = _g.next();
                        return [3 /*break*/, 25];
                    case 28: return [3 /*break*/, 31];
                    case 29:
                        e_4_1 = _o.sent();
                        e_4 = { error: e_4_1 };
                        return [3 /*break*/, 31];
                    case 30:
                        try {
                            if (_h && !_h.done && (_m = _g["return"])) _m.call(_g);
                        }
                        finally { if (e_4) throw e_4.error; }
                        return [7 /*endfinally*/];
                    case 31: return [4 /*yield*/, this.dataSource.setToken(collection.nextSyncToken)];
                    case 32:
                        _o.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return SyncEngine;
}());
exports.SyncEngine = SyncEngine;
/**
 * Enhances a dataSource with a Contentful client to keep it up to date via the
 * Sync API.
 * @param dataSource The data source to store data e.g. InMemoryDataSource, PostgresDataSource
 * @param client The Contentful client that allows us to sync data to the data source
 * @returns The same data source enhanced with the sync() method
 */
function withSync(dataSource, client) {
    var syncEngine = new SyncEngine(dataSource, client);
    return Object.assign(dataSource, {
        sync: syncEngine.sync.bind(syncEngine)
    });
}
exports.withSync = withSync;
/**
 * Enhances a dataSource with a Contentful client to keep it up to date via the
 * Sync API.
 * @param dataSource The data source to store data e.g. InMemoryDataSource, PostgresDataSource
 * @param client The Contentful client that allows us to sync data to the data source
 * @returns The same data source enhanced with the sync() method
 */
function addSync(dataSource, client) {
    withSync(dataSource, client);
}
exports.addSync = addSync;
function isSyncable(dataSource) {
    return typeof dataSource.index === 'function';
}
exports.isSyncable = isSyncable;
function hasSync(dataSource) {
    return typeof dataSource.sync === 'function';
}
exports.hasSync = hasSync;
//# sourceMappingURL=index.js.map