import type { Resolver } from '@apollo/client';
import { GraphQLInterfaceType, GraphQLObjectType, GraphQLScalarType } from 'graphql';
export declare const GraphQLNever: GraphQLScalarType<unknown, null>;
export type Namespace = ReturnType<typeof namespace>;
export declare function namespace(ns?: string): {
    _name: string | undefined;
    Asset: GraphQLObjectType<any, any>;
    AssetCollection: GraphQLObjectType<any, any>;
    ContentfulMetadata: GraphQLObjectType<any, any>;
    ContentfulTag: GraphQLObjectType<any, any>;
    Entry: GraphQLInterfaceType;
    EntryCollection: GraphQLObjectType<any, any>;
    Sys: GraphQLObjectType<any, any>;
    GraphQLLocation: GraphQLObjectType<any, any>;
    toType: (name: string) => string;
};
export declare function namespacedTypeName(name: string, namespace: string | undefined): string;
export declare function assetFieldResolver(namespace: string | undefined): {
    [field: string]: Resolver;
};
